searchNodes=[{"doc":"Handles downloading files via HTTP. internally caches several interesting properties about the download such as:the URI of the requestthe total content amounts of bytes of the file being downloadedthe total amount of bytes downloaded at any given timeUsing this information, it can restart a download using the Range HTTP header.This process's only focus is obtaining data reliably. It doesn't have any side effects on the system.","ref":"NervesHubLinkCommon.Downloader.html","title":"NervesHubLinkCommon.Downloader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"NervesHubLinkCommon.Downloader.html#child_spec/1","title":"NervesHubLinkCommon.Downloader.child_spec/1","type":"function"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#handle_response/2","title":"NervesHubLinkCommon.Downloader.handle_response/2","type":"function"},{"doc":"Begins downloading a file at url handled by fun.Example iex&gt; pid = self() #PID&lt;0.110.0&gt; iex&gt; fun = fn {:data, data} -&gt; File.write(&quot;index.html&quot;, data) ...&gt; {:error, error} -&gt; IO.puts(&quot;error streaming file: \#{inspect(error)}&quot;) ...&gt; :complete -&gt; send pid, :complete ...&gt; end #Function&lt;44.97283095/1 in :erl_eval.expr/5&gt; iex&gt; NervesHubLinkCommon.Downloader.start_download(&quot;https://httpbin.com/&quot;, fun) {:ok, #PID&lt;0.111.0&gt;} iex&gt; flush() :complete","ref":"NervesHubLinkCommon.Downloader.html#start_download/2","title":"NervesHubLinkCommon.Downloader.start_download/2","type":"function"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#start_download/3","title":"NervesHubLinkCommon.Downloader.start_download/3","type":"function"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#t:event_handler_fun/0","title":"NervesHubLinkCommon.Downloader.event_handler_fun/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#t:handler_event/0","title":"NervesHubLinkCommon.Downloader.handler_event/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#t:initialized_download/0","title":"NervesHubLinkCommon.Downloader.initialized_download/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#t:resume_rescheduled/0","title":"NervesHubLinkCommon.Downloader.resume_rescheduled/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#t:retry_args/0","title":"NervesHubLinkCommon.Downloader.retry_args/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.html#t:t/0","title":"NervesHubLinkCommon.Downloader.t/0","type":"type"},{"doc":"Configuration structure for how the Downloader server will handle disconnects, errors, timeouts etc","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html","title":"NervesHubLinkCommon.Downloader.RetryConfig","type":"module"},{"doc":"time in milliseconds between chunks of data received that once elapsed will trigger a retry. This event counts towards the max_disconnects counter","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html#t:idle_timeout/0","title":"NervesHubLinkCommon.Downloader.RetryConfig.idle_timeout/0","type":"type"},{"doc":"maximum number of disconnects. After this limit is reached the download will be stopped and will no longer be retried","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html#t:max_disconnects/0","title":"NervesHubLinkCommon.Downloader.RetryConfig.max_disconnects/0","type":"type"},{"doc":"maximum time in milliseconds that a download can exist for. after this amount of time has elapsed, the download is canceled and the download process will crash","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html#t:max_timeout/0","title":"NervesHubLinkCommon.Downloader.RetryConfig.max_timeout/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html#t:t/0","title":"NervesHubLinkCommon.Downloader.RetryConfig.t/0","type":"type"},{"doc":"time in milliseconds to wait before attempting to retry a download","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html#t:time_between_retries/0","title":"NervesHubLinkCommon.Downloader.RetryConfig.time_between_retries/0","type":"type"},{"doc":"worst case download speed specified in bytes per second. This is used to calculate the &quot;worst case&quot; download timeout. it is meant to fail faster than waiting for max_timeout to elapse","ref":"NervesHubLinkCommon.Downloader.RetryConfig.html#t:worst_case_download_speed/0","title":"NervesHubLinkCommon.Downloader.RetryConfig.worst_case_download_speed/0","type":"type"},{"doc":"Pure functions for dealing with timeouts","ref":"NervesHubLinkCommon.Downloader.TimeoutCalculation.html","title":"NervesHubLinkCommon.Downloader.TimeoutCalculation","type":"module"},{"doc":"Calculates the worst_case_timeout value based on content_length header and worst case network speed","ref":"NervesHubLinkCommon.Downloader.TimeoutCalculation.html#calculate_worst_case_timeout/2","title":"NervesHubLinkCommon.Downloader.TimeoutCalculation.calculate_worst_case_timeout/2","type":"function"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.TimeoutCalculation.html#t:bits_per_second/0","title":"NervesHubLinkCommon.Downloader.TimeoutCalculation.bits_per_second/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Downloader.TimeoutCalculation.html#t:number_of_bytes/0","title":"NervesHubLinkCommon.Downloader.TimeoutCalculation.number_of_bytes/0","type":"type"},{"doc":"Config structure responsible for handling callbacks from FWUP, applying a fwupdate, and storing fwup task configuration","ref":"NervesHubLinkCommon.FwupConfig.html","title":"NervesHubLinkCommon.FwupConfig","type":"module"},{"doc":"Raises an ArgumentError on invalid arguments","ref":"NervesHubLinkCommon.FwupConfig.html#validate!/1","title":"NervesHubLinkCommon.FwupConfig.validate!/1","type":"function"},{"doc":"handle_fwup_message will be called with this data","ref":"NervesHubLinkCommon.FwupConfig.html#t:fwup_message/0","title":"NervesHubLinkCommon.FwupConfig.fwup_message/0","type":"type"},{"doc":"Callback that will be called during the lifecycle of a fwupdate being applied","ref":"NervesHubLinkCommon.FwupConfig.html#t:handle_fwup_message_fun/0","title":"NervesHubLinkCommon.FwupConfig.handle_fwup_message_fun/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.FwupConfig.html#t:t/0","title":"NervesHubLinkCommon.FwupConfig.t/0","type":"type"},{"doc":"Called when an update has been dispatched via NervesHubLinkCommon.UpdateManager.apply_update/2","ref":"NervesHubLinkCommon.FwupConfig.html#t:update_available_fun/0","title":"NervesHubLinkCommon.FwupConfig.update_available_fun/0","type":"type"},{"doc":"Structure containing metadata about a firmware.","ref":"NervesHubLinkCommon.Message.FirmwareMetadata.html","title":"NervesHubLinkCommon.Message.FirmwareMetadata","type":"module"},{"doc":"","ref":"NervesHubLinkCommon.Message.FirmwareMetadata.html#parse/1","title":"NervesHubLinkCommon.Message.FirmwareMetadata.parse/1","type":"function"},{"doc":"","ref":"NervesHubLinkCommon.Message.FirmwareMetadata.html#t:t/0","title":"NervesHubLinkCommon.Message.FirmwareMetadata.t/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.Message.UpdateInfo.html","title":"NervesHubLinkCommon.Message.UpdateInfo","type":"module"},{"doc":"Parse an update message from NervesHub","ref":"NervesHubLinkCommon.Message.UpdateInfo.html#parse/1","title":"NervesHubLinkCommon.Message.UpdateInfo.parse/1","type":"function"},{"doc":"Payload that gets dispatched down to devices upon an updatefirmware_url and firmware_meta are only available when update_available is true.","ref":"NervesHubLinkCommon.Message.UpdateInfo.html#t:t/0","title":"NervesHubLinkCommon.Message.UpdateInfo.t/0","type":"type"},{"doc":"GenServer responsible for brokering messages between:an external controlling processFWUPHTTPShould be started in a supervision tree","ref":"NervesHubLinkCommon.UpdateManager.html","title":"NervesHubLinkCommon.UpdateManager","type":"module"},{"doc":"Must be called when an update payload is dispatched from NervesHub. the map must contain a &quot;firmware_url&quot; key.","ref":"NervesHubLinkCommon.UpdateManager.html#apply_update/2","title":"NervesHubLinkCommon.UpdateManager.apply_update/2","type":"function"},{"doc":"Returns the UUID of the currently downloading firmware, or nil.","ref":"NervesHubLinkCommon.UpdateManager.html#currently_downloading_uuid/1","title":"NervesHubLinkCommon.UpdateManager.currently_downloading_uuid/1","type":"function"},{"doc":"Returns the current status of the update manager","ref":"NervesHubLinkCommon.UpdateManager.html#status/1","title":"NervesHubLinkCommon.UpdateManager.status/1","type":"function"},{"doc":"Structure for the state of the UpdateManager server. Contains types that describe status and different states the UpdateManager can be in","ref":"NervesHubLinkCommon.UpdateManager.State.html","title":"NervesHubLinkCommon.UpdateManager.State","type":"module"},{"doc":"","ref":"NervesHubLinkCommon.UpdateManager.State.html#t:status/0","title":"NervesHubLinkCommon.UpdateManager.State.status/0","type":"type"},{"doc":"","ref":"NervesHubLinkCommon.UpdateManager.State.html#t:t/0","title":"NervesHubLinkCommon.UpdateManager.State.t/0","type":"type"},{"doc":"NervesHubLinkCommon Common library that should be shared between the websocket and http connections.Handles resumable HTTP streams to fwup.NOTEYou probably don't need this library directly. See the above linked libraries.","ref":"readme.html","title":"NervesHubLinkCommon","type":"extras"},{"doc":"The main API to this application is NervesHubLinkCommon.UpdateManager. It is meant to be started as a child in a supervision tree:require Logger alias NervesHubLinkCommon.{UpdateManager, FwupConfig} def handle_fwup_message({:ok, _status, message}), do: Logger.info(&quot;Firmware update complete: \#{message} going down for reboot...&quot;) def handle_fwup_message({:warning, _status, message}), do: Logger.warn(&quot;Firmware update warning: \#{message}&quot;) def handle_fwup_message({:error, _status, message}), do: Logger.error(&quot;Firmware update failed: \#{message}&quot;) def handle_fwup_message({:progress, percent}), do: Logger.error(&quot;Firmware update progress: \#{percent}%&quot;) def update_available(%{&quot;firmware_url&quot; =&gt; _}) do if SomeExternalApi.is_now_a_good_time_for_a_firmware_update?() do :apply else {:reschedule, 60_000} end end def init(_) do fwup_config = %FwupConfig{ fwup_public_keys: [&quot;Qqyf/7JrIt06+xzvF6a5CgNj8/CZfHUemTa32R8effM=&quot;], fwup_devpath: &quot;/dev/mmcblk0p1&quot;, handle_fwup_message: &amp;handle_fwup_message/1, update_available: &amp;update_available/1 } children = [{UpdateManager, fwup_config}] Supervisor.init(children, [strategy: :one_for_one]) end","ref":"readme.html#usage","title":"NervesHubLinkCommon - Usage","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This release has an API breaking change. You're probably using this library as a result of depending on nerves_hub_link so these changes won't affect your application code.New featuresOn reconnecting to a NervesHub instance, an firmware download that's in process will be reportedBug fixesProperly ignore NervesHub responses that indicate no update is available.API breaking change:apply_update/1 now returns a %NervesHubLinkCommon.Message.UpdateInfo{}","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"New featuresNew RetryConfig param: worst_case_download_speed. This makes it possible to match the timeout to the download size and fail before max_timeout.max_timeout is now 24 hours to match the NervesHub download URL validity time. Now downloads can survive multi-hour network outages without starting over.","ref":"changelog.html#v0-1-3","title":"Changelog - v0.1.3","type":"extras"},{"doc":"Bug FixesFix issue where query parameters were not being encoded correctly","ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras"},{"doc":"Retired due to typo","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Initial Release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]